Benchmarks
---

*Dislcaimer: remember benchmarks are generally fraught with issues and their
legitimacy depends on a multitude of factors.*

I've used basic, but seemingly nice, [`pytest-benchmark`](https://pytest-benchmark.readthedocs.io/en/stable/usage.html)
to produce the following benchmarks on a fairly modern machine.

If you'd like to run these yourself, you'll need whatever according system 
dependency, if any, required by the specific algorithm as well as the Python
lib installed. Can install all via `pip install -r benchmark-requirements.txt`. 

The resulting output from benchmarks indicate what file and lib was used, (`cramjam` vs `gzip`)
`test_gzip[urls.10K-cramjam]` indicates `cramjam` and `benchmarks/data/urls.10K` file was used during the gzip benchmark.

--- 

#### Gzip

`make bench-gzip`

```bash 
--------------------------------------------------------------------------------------------------------- benchmark: 24 tests ---------------------------------------------------------------------------------------------------------
Name (time in us)                                        Min                    Max                   Mean              StdDev                 Median                 IQR            Outliers         OPS            Rounds  Iterations
---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
test_gzip[Mark.Twain-Tom.Sawyer.txt-cramjam]        497.7920 (1.0)         927.0370 (1.0)         512.6448 (1.0)       38.7377 (1.03)        501.2350 (1.0)        4.6807 (1.0)        89;331  1,950.6684 (1.0)        1533           1
test_gzip[Mark.Twain-Tom.Sawyer.txt-gzip]           573.7430 (1.15)        986.6440 (1.06)        591.0132 (1.15)      37.5584 (1.0)         578.2010 (1.15)      14.7650 (3.15)       97;163  1,692.0095 (0.87)       1470           1
test_gzip[alice29.txt-cramjam]                   10,788.0000 (21.67)    13,869.3350 (14.96)    11,136.2440 (21.72)    522.4084 (13.91)    11,004.6575 (21.96)    145.8700 (31.16)         5;8     89.7969 (0.05)         90           1
test_gzip[alice29.txt-gzip]                      11,869.4080 (23.84)    14,129.1380 (15.24)    12,164.6976 (23.73)    403.3387 (10.74)    12,050.8860 (24.04)    168.4588 (35.99)         5;6     82.2051 (0.04)         83           1
test_gzip[asyoulik.txt-cramjam]                   8,285.3550 (16.64)    11,234.8790 (12.12)     8,510.5130 (16.60)    423.3875 (11.27)     8,410.6555 (16.78)    114.5175 (24.47)        6;13    117.5017 (0.06)        120           1
test_gzip[asyoulik.txt-gzip]                      8,952.9650 (17.99)    11,291.9470 (12.18)     9,346.9739 (18.23)    415.8719 (11.07)     9,241.8710 (18.44)    145.0840 (31.00)        7;10    106.9865 (0.05)         90           1
test_gzip[fireworks.jpeg-cramjam]                 3,822.6550 (7.68)      6,172.2910 (6.66)      3,983.1931 (7.77)     326.3236 (8.69)      3,891.8400 (7.76)     123.2523 (26.33)        8;11    251.0549 (0.13)        147           1
test_gzip[fireworks.jpeg-gzip]                    3,197.8900 (6.42)      5,114.0700 (5.52)      3,306.4640 (6.45)     208.9637 (5.56)      3,260.7100 (6.51)     101.4152 (21.67)        9;10    302.4379 (0.16)        285           1
test_gzip[geo.protodata-cramjam]                  1,577.1590 (3.17)      2,818.3670 (3.04)      1,654.2466 (3.23)     144.8015 (3.86)      1,614.0270 (3.22)      63.4920 (13.56)       31;37    604.5048 (0.31)        574           1
test_gzip[geo.protodata-gzip]                     2,113.4380 (4.25)      3,371.9360 (3.64)      2,211.3350 (4.31)     127.9896 (3.41)      2,169.3200 (4.33)      84.6785 (18.09)       26;24    452.2155 (0.23)        429           1
test_gzip[html-cramjam]                           1,956.7170 (3.93)      3,061.7890 (3.30)      2,028.4278 (3.96)     121.2626 (3.23)      1,990.7950 (3.97)      75.0007 (16.02)       29;28    492.9926 (0.25)        439           1
test_gzip[html-gzip]                              2,458.9250 (4.94)      3,761.2100 (4.06)      2,540.1700 (4.96)     135.4718 (3.61)      2,504.6555 (5.00)      89.0160 (19.02)       21;16    393.6744 (0.20)        390           1
test_gzip[html_x_4-cramjam]                       9,322.9810 (18.73)    11,875.0880 (12.81)     9,564.6007 (18.66)    366.2080 (9.75)      9,482.4370 (18.92)    138.2243 (29.53)         6;8    104.5522 (0.05)        107           1
test_gzip[html_x_4-gzip]                         10,878.6620 (21.85)    13,747.6080 (14.83)    11,147.0642 (21.74)    395.4767 (10.53)    11,072.2015 (22.09)    140.1490 (29.94)         4;5     89.7097 (0.05)         90           1
test_gzip[kppkn.gtb-cramjam]                     39,047.1010 (78.44)    41,982.6430 (45.29)    39,376.7768 (76.81)    574.0887 (15.29)    39,231.4520 (78.27)    179.2995 (38.31)         1;1     25.3957 (0.01)         24           1
test_gzip[kppkn.gtb-gzip]                        62,117.8520 (124.79)   64,566.2150 (69.65)    62,617.8781 (122.15)   730.3686 (19.45)    62,403.7350 (124.50)   133.9970 (28.63)         2;2     15.9699 (0.01)         16           1
test_gzip[lcet10.txt-cramjam]                    26,369.5180 (52.97)    29,075.0250 (31.36)    26,686.8723 (52.06)    447.7174 (11.92)    26,645.4015 (53.16)    185.7090 (39.68)         1;2     37.4716 (0.02)         34           1
test_gzip[lcet10.txt-gzip]                       29,200.5550 (58.66)    32,278.3550 (34.82)    29,595.5600 (57.73)    546.9773 (14.56)    29,446.1480 (58.75)    150.3415 (32.12)         3;4     33.7889 (0.02)         31           1
test_gzip[paper-100k.pdf-cramjam]                 2,770.0760 (5.56)      4,955.2750 (5.35)      2,878.5382 (5.62)     246.0345 (6.55)      2,814.7090 (5.62)     100.5495 (21.48)       14;15    347.3985 (0.18)        355           1
test_gzip[paper-100k.pdf-gzip]                    3,214.4760 (6.46)      5,073.3990 (5.47)      3,339.4041 (6.51)     196.4699 (5.23)      3,277.1590 (6.54)     117.5240 (25.11)       18;18    299.4546 (0.15)        295           1
test_gzip[plrabn12.txt-cramjam]                  48,263.9040 (96.96)    50,260.6310 (54.22)    48,724.9557 (95.05)    550.9577 (14.67)    48,620.2370 (97.00)    470.5795 (100.54)        2;2     20.5234 (0.01)         20           1
test_gzip[plrabn12.txt-gzip]                     52,464.0520 (105.39)   54,261.8340 (58.53)    52,956.9974 (103.30)   505.1568 (13.45)    52,805.4230 (105.35)   561.5632 (119.97)        3;1     18.8832 (0.01)         19           1
test_gzip[urls.10K-cramjam]                      35,862.0130 (72.04)    38,657.0320 (41.70)    36,375.8052 (70.96)    524.4842 (13.96)    36,286.5185 (72.39)    441.9370 (94.42)         1;1     27.4908 (0.01)         26           1
test_gzip[urls.10K-gzip]                         39,871.9070 (80.10)    41,759.3410 (45.05)    40,245.7284 (78.51)    479.4244 (12.76)    40,118.9995 (80.04)    261.3920 (55.84)         2;3     24.8474 (0.01)         24           1
---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

```

#### Snappy

`make bench-snappy`

```bash
--------------------------------------------------------------------------------------------------------- benchmark: 24 tests ----------------------------------------------------------------------------------------------------------
Name (time in us)                                             Min                   Max                  Mean             StdDev                Median                IQR            Outliers          OPS            Rounds  Iterations
----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
test_snappy_raw[Mark.Twain-Tom.Sawyer.txt-cramjam]        52.3690 (3.40)       115.8890 (2.22)        55.2396 (3.43)      5.9556 (3.52)        53.4210 (3.39)      1.1660 (4.29)    1048;1401  18,102.9494 (0.29)      11589           1
test_snappy_raw[Mark.Twain-Tom.Sawyer.txt-snappy]         52.6630 (3.41)       108.0780 (2.07)        54.2757 (3.37)      3.3904 (2.00)        53.5820 (3.40)      0.3935 (1.45)     488;1355  18,424.4486 (0.30)      12256           1
test_snappy_raw[alice29.txt-cramjam]                     614.1800 (39.82)      951.0760 (18.25)      632.5591 (39.32)    25.7672 (15.23)      621.4280 (39.41)    18.8097 (69.15)     173;112   1,580.8800 (0.03)       1565           1
test_snappy_raw[alice29.txt-snappy]                      600.9050 (38.96)      857.3690 (16.45)      616.9804 (38.35)    24.8116 (14.66)      604.3860 (38.33)    19.9527 (73.36)      164;90   1,620.7971 (0.03)       1391           1
test_snappy_raw[asyoulik.txt-cramjam]                    548.1430 (35.54)      820.2290 (15.74)      562.4624 (34.96)    21.9863 (12.99)      553.0150 (35.07)    15.2803 (56.18)     217;168   1,777.8965 (0.03)       1767           1
test_snappy_raw[asyoulik.txt-snappy]                     533.1530 (34.56)      712.1160 (13.66)      547.3970 (34.03)    23.3257 (13.78)      536.1730 (34.01)    16.1405 (59.34)     195;158   1,826.8277 (0.03)       1836           1
test_snappy_raw[fireworks.jpeg-cramjam]                   36.8510 (2.39)        80.3290 (1.54)        38.4149 (2.39)      3.3261 (1.97)        37.5030 (2.38)      0.9852 (3.62)     769;1143  26,031.5717 (0.42)      18833           1
test_snappy_raw[fireworks.jpeg-snappy]                    15.4250 (1.0)         52.1130 (1.0)         16.0880 (1.0)       1.6923 (1.0)         15.7670 (1.0)       0.2720 (1.0)      843;3054  62,158.2882 (1.0)       36288           1
test_snappy_raw[geo.protodata-cramjam]                   159.0690 (10.31)      277.0210 (5.32)       164.3288 (10.21)    10.5643 (6.24)       161.3640 (10.23)     1.3160 (4.84)     394;1085   6,085.3621 (0.10)       5532           1
test_snappy_raw[geo.protodata-snappy]                    143.0880 (9.28)       427.6350 (8.21)       149.2621 (9.28)     10.3206 (6.10)       146.8510 (9.31)      2.2190 (8.16)      423;863   6,699.6256 (0.11)       6144           1
test_snappy_raw[html-cramjam]                            168.1440 (10.90)      467.2520 (8.97)       174.6428 (10.86)    14.7798 (8.73)       170.3380 (10.80)     2.6872 (9.88)      364;676   5,725.9735 (0.09)       5397           1
test_snappy_raw[html-snappy]                             156.3440 (10.14)      280.2920 (5.38)       160.8994 (10.00)     9.7030 (5.73)       158.0980 (10.03)     1.1595 (4.26)     373;1257   6,215.0630 (0.10)       5811           1
test_snappy_raw[html_x_4-cramjam]                        694.2620 (45.01)      900.5190 (17.28)      711.4322 (44.22)    27.8857 (16.48)      698.9225 (44.33)    20.0220 (73.61)      116;84   1,405.6153 (0.02)       1034           1
test_snappy_raw[html_x_4-snappy]                         633.0930 (41.04)      864.6650 (16.59)      649.1615 (40.35)    27.1781 (16.06)      637.7115 (40.45)    17.9000 (65.81)     160;114   1,540.4487 (0.02)       1538           1
test_snappy_raw[kppkn.gtb-cramjam]                       516.7710 (33.50)      760.5490 (14.59)      530.4332 (32.97)    23.1890 (13.70)      520.5000 (33.01)    14.7900 (54.37)     184;165   1,885.2514 (0.03)       1811           1
test_snappy_raw[kppkn.gtb-snappy]                        503.7630 (32.66)      702.6630 (13.48)      516.1728 (32.08)    21.9923 (13.00)      505.8520 (32.08)    14.5700 (53.57)     214;193   1,937.3358 (0.03)       1944           1
test_snappy_raw[lcet10.txt-cramjam]                    1,641.4740 (106.42)   2,062.8950 (39.59)    1,676.7033 (104.22)   48.0968 (28.42)    1,655.1000 (104.97)   40.8570 (150.21)      75;57     596.4084 (0.01)        546           1
test_snappy_raw[lcet10.txt-snappy]                     1,590.3140 (103.10)   1,956.3550 (37.54)    1,626.9634 (101.13)   47.5634 (28.11)    1,600.7900 (101.53)   41.9140 (154.10)      97;60     614.6420 (0.01)        621           1
test_snappy_raw[paper-100k.pdf-cramjam]                   36.2280 (2.35)        80.2130 (1.54)        37.8268 (2.35)      3.4155 (2.02)        37.0410 (2.35)      0.5730 (2.11)     813;2607  26,436.3044 (0.43)      17202           1
test_snappy_raw[paper-100k.pdf-snappy]                    20.5150 (1.33)       213.3630 (4.09)        21.5959 (1.34)      2.5731 (1.52)        21.1570 (1.34)      0.3500 (1.29)     828;2983  46,304.9918 (0.74)      26395           1
test_snappy_raw[plrabn12.txt-cramjam]                  2,411.8190 (156.36)   3,147.9140 (60.41)    2,612.8756 (162.41)   67.9935 (40.18)    2,593.1220 (164.47)   85.0065 (312.52)       51;9     382.7201 (0.01)        364           1
test_snappy_raw[plrabn12.txt-snappy]                   2,186.4340 (141.75)   2,516.2830 (48.29)    2,231.8268 (138.73)   50.8453 (30.05)    2,214.3780 (140.44)   60.5810 (222.72)      68;13     448.0634 (0.01)        402           1
test_snappy_raw[urls.10K-cramjam]                      2,368.2700 (153.53)   2,713.3270 (52.07)    2,421.8313 (150.54)   58.8285 (34.76)    2,396.8985 (152.02)   66.5005 (244.49)      66;15     412.9107 (0.01)        376           1
test_snappy_raw[urls.10K-snappy]                       1,813.1410 (117.55)   2,218.1260 (42.56)    1,850.6340 (115.03)   49.7677 (29.41)    1,834.3030 (116.34)   43.2400 (158.97)      76;49     540.3553 (0.01)        464           1
----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
```

#### Lz4

`make bench-lz4`

```bash
---------------------------------------------------------------------------------------------------------- benchmark: 24 tests ----------------------------------------------------------------------------------------------------------
Name (time in us)                                          Min                    Max                   Mean              StdDev                 Median                 IQR            Outliers         OPS            Rounds  Iterations
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
test_lz4[Mark.Twain-Tom.Sawyer.txt-cramjam]           203.4740 (1.0)         444.8800 (1.38)        224.6050 (1.06)      26.0675 (1.88)        216.5980 (1.05)       8.5017 (8.80)      365;607  4,452.2600 (0.94)       4369           1
test_lz4[Mark.Twain-Tom.Sawyer.txt-python-lz4]        205.5300 (1.01)        323.3270 (1.0)         212.0422 (1.0)       13.9019 (1.0)         206.8320 (1.0)        3.3853 (3.50)      157;196  4,716.0415 (1.0)        1343           1
test_lz4[alice29.txt-cramjam]                       1,923.4740 (9.45)      2,223.4950 (6.88)      1,965.3029 (9.27)      47.7473 (3.43)      1,949.8210 (9.43)      52.7460 (54.60)       75;32    508.8274 (0.11)        522           1
test_lz4[alice29.txt-python-lz4]                    3,041.9810 (14.95)     3,775.3870 (11.68)     3,101.6142 (14.63)     75.2325 (5.41)      3,070.2935 (14.84)     86.3640 (89.40)        41;6    322.4128 (0.07)        284           1
test_lz4[asyoulik.txt-cramjam]                      1,513.2880 (7.44)      1,909.5500 (5.91)      1,547.3341 (7.30)      44.6617 (3.21)      1,522.1690 (7.36)      42.7083 (44.21)       93;45    646.2728 (0.14)        625           1
test_lz4[asyoulik.txt-python-lz4]                   2,721.3430 (13.37)     3,034.5050 (9.39)      2,775.2225 (13.09)     59.9928 (4.32)      2,750.2920 (13.30)     75.6480 (78.31)        60;9    360.3315 (0.08)        351           1
test_lz4[fireworks.jpeg-cramjam]                      302.6000 (1.49)        428.0990 (1.32)        309.0598 (1.46)      15.2582 (1.10)        303.5465 (1.47)       0.9660 (1.0)       187;514  3,235.6199 (0.69)       2132           1
test_lz4[fireworks.jpeg-python-lz4]                 2,648.8040 (13.02)     3,357.4280 (10.38)     2,728.6830 (12.87)     71.7825 (5.16)      2,706.7730 (13.09)     78.2895 (81.05)       53;11    366.4772 (0.08)        359           1
test_lz4[geo.protodata-cramjam]                       508.2790 (2.50)        646.2610 (2.00)        521.5591 (2.46)      20.3970 (1.47)        512.9110 (2.48)       9.2445 (9.57)      182;244  1,917.3284 (0.41)       1704           1
test_lz4[geo.protodata-python-lz4]                    690.1580 (3.39)      1,039.7180 (3.22)        711.8781 (3.36)      28.5339 (2.05)        700.7910 (3.39)      16.3645 (16.94)     111;108  1,404.7349 (0.30)       1136           1
test_lz4[html-cramjam]                                532.0860 (2.62)        692.3440 (2.14)        544.6823 (2.57)      22.7418 (1.64)        534.2530 (2.58)      15.3568 (15.90)     165;143  1,835.9326 (0.39)       1439           1
test_lz4[html-python-lz4]                             697.1870 (3.43)      1,348.5820 (4.17)        720.6965 (3.40)      58.3927 (4.20)        705.8270 (3.41)      19.6258 (20.32)      74;110  1,387.5467 (0.29)       1283           1
test_lz4[html_x_4-cramjam]                          2,250.3640 (11.06)     2,993.5320 (9.26)      2,294.9767 (10.82)     57.7055 (4.15)      2,278.1760 (11.01)     57.5988 (59.63)        39;9    435.7343 (0.09)        335           1
test_lz4[html_x_4-python-lz4]                       2,864.5650 (14.08)     3,763.0070 (11.64)     2,949.5807 (13.91)    102.1472 (7.35)      2,926.3090 (14.15)     86.7158 (89.77)       23;13    339.0312 (0.07)        305           1
test_lz4[kppkn.gtb-cramjam]                         1,825.6790 (8.97)      2,237.8240 (6.92)      1,862.1173 (8.78)      48.1581 (3.46)      1,849.8330 (8.94)      42.7253 (44.23)       51;29    537.0231 (0.11)        439           1
test_lz4[kppkn.gtb-python-lz4]                      3,231.7460 (15.88)     3,588.2730 (11.10)     3,316.1698 (15.64)     62.4040 (4.49)      3,294.2780 (15.93)     83.7080 (86.65)        56;9    301.5527 (0.06)        292           1
test_lz4[lcet10.txt-cramjam]                        5,081.3180 (24.97)     8,123.0820 (25.12)     5,204.8228 (24.55)    251.5433 (18.09)     5,151.7120 (24.91)    113.3202 (117.31)       7;11    192.1295 (0.04)        195           1
test_lz4[lcet10.txt-python-lz4]                     8,138.7970 (40.00)    10,127.4950 (31.32)     8,333.2891 (39.30)    218.4185 (15.71)     8,300.2250 (40.13)    161.9515 (167.65)        9;6    120.0006 (0.03)        117           1
test_lz4[paper-100k.pdf-cramjam]                      418.5770 (2.06)        689.9690 (2.13)        428.1164 (2.02)      21.2000 (1.52)        420.0800 (2.03)       4.1125 (4.26)      191;476  2,335.8133 (0.50)       2133           1
test_lz4[paper-100k.pdf-python-lz4]                 1,711.3010 (8.41)      2,172.5910 (6.72)      1,749.2066 (8.25)      45.5884 (3.28)      1,728.4740 (8.36)      41.2590 (42.71)       66;44    571.6878 (0.12)        538           1
test_lz4[plrabn12.txt-cramjam]                      6,176.6160 (30.36)     6,769.9650 (20.94)     6,291.9010 (29.67)    104.2639 (7.50)      6,270.1985 (30.32)    123.0515 (127.38)       36;6    158.9345 (0.03)        156           1
test_lz4[plrabn12.txt-python-lz4]                  11,555.2180 (56.79)    12,696.5330 (39.27)    11,776.3184 (55.54)    164.0822 (11.80)    11,730.5170 (56.72)    145.7985 (150.93)       15;3     84.9162 (0.02)         84           1
test_lz4[urls.10K-cramjam]                          6,161.1970 (30.28)     6,947.9270 (21.49)     6,294.6157 (29.69)    118.5858 (8.53)      6,283.8170 (30.38)    157.5450 (163.09)       36;4    158.8659 (0.03)        166           1
test_lz4[urls.10K-python-lz4]                       9,186.5620 (45.15)     9,727.7520 (30.09)     9,330.3774 (44.00)     97.1408 (6.99)      9,324.5380 (45.08)    114.7825 (118.82)       29;4    107.1768 (0.02)        105           1
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
```

#### Brotli

`make bench-brotli`

```bash
----------------------------------------------------------------------------------------------------- benchmark: 24 tests ------------------------------------------------------------------------------------------------------
Name (time in ms)                                         Min                   Max                  Mean             StdDev                Median                IQR            Outliers      OPS            Rounds  Iterations
--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
test_brotli[Mark.Twain-Tom.Sawyer.txt-brotli]         17.9007 (1.0)         18.5634 (1.0)         18.0894 (1.0)       0.1631 (1.0)         18.0193 (1.0)       0.1939 (1.0)          10;1  55.2809 (1.0)          43           1
test_brotli[Mark.Twain-Tom.Sawyer.txt-cramjam]        19.0021 (1.06)        19.8885 (1.07)        19.2310 (1.06)      0.1936 (1.19)        19.1951 (1.07)      0.2085 (1.07)         15;2  51.9994 (0.94)         51           1
test_brotli[alice29.txt-brotli]                      220.5389 (12.32)      221.1390 (11.91)      220.7948 (12.21)     0.2183 (1.34)       220.7497 (12.25)     0.2151 (1.11)          2;0   4.5291 (0.08)          5           1
test_brotli[alice29.txt-cramjam]                     232.1295 (12.97)      233.8130 (12.60)      232.9461 (12.88)     0.7112 (4.36)       233.1537 (12.94)     1.1918 (6.15)          2;0   4.2928 (0.08)          5           1
test_brotli[asyoulik.txt-brotli]                     174.3166 (9.74)       175.6382 (9.46)       175.1187 (9.68)      0.5167 (3.17)       175.3066 (9.73)      0.8275 (4.27)          2;0   5.7104 (0.10)          6           1
test_brotli[asyoulik.txt-cramjam]                    184.5938 (10.31)      187.0546 (10.08)      185.4668 (10.25)     0.9035 (5.54)       185.3526 (10.29)     1.1405 (5.88)          1;0   5.3918 (0.10)          6           1
test_brotli[fireworks.jpeg-brotli]                    70.5355 (3.94)        82.0225 (4.42)        71.7829 (3.97)      2.9634 (18.17)       70.9972 (3.94)      0.5353 (2.76)          1;1  13.9309 (0.25)         14           1
test_brotli[fireworks.jpeg-cramjam]                   76.9092 (4.30)        81.3156 (4.38)        77.7946 (4.30)      1.2098 (7.42)        77.4907 (4.30)      0.8702 (4.49)          1;1  12.8544 (0.23)         13           1
test_brotli[geo.protodata-brotli]                    123.9892 (6.93)       126.4977 (6.81)       124.9959 (6.91)      1.0019 (6.14)       124.7437 (6.92)      1.6731 (8.63)          3;0   8.0003 (0.14)          8           1
test_brotli[geo.protodata-cramjam]                   127.8089 (7.14)       129.7215 (6.99)       128.3528 (7.10)      0.6489 (3.98)       128.1646 (7.11)      0.6682 (3.45)          1;1   7.7910 (0.14)          8           1
test_brotli[html-brotli]                             132.3877 (7.40)       139.4814 (7.51)       134.3966 (7.43)      2.8777 (17.64)      132.9534 (7.38)      3.0888 (15.93)         2;0   7.4407 (0.13)          8           1
test_brotli[html-cramjam]                            134.8224 (7.53)       140.8846 (7.59)       136.1176 (7.52)      1.9671 (12.06)      135.6059 (7.53)      0.7402 (3.82)          1;1   7.3466 (0.13)          8           1
test_brotli[html_x_4-brotli]                         161.5212 (9.02)       163.8326 (8.83)       162.3997 (8.98)      0.8996 (5.51)       161.8780 (8.98)      1.4229 (7.34)          1;0   6.1576 (0.11)          7           1
test_brotli[html_x_4-cramjam]                        169.5740 (9.47)       171.0375 (9.21)       170.2433 (9.41)      0.5199 (3.19)       170.1756 (9.44)      0.7178 (3.70)          2;0   5.8739 (0.11)          6           1
test_brotli[kppkn.gtb-brotli]                        417.5436 (23.33)      419.3681 (22.59)      418.4432 (23.13)     0.8296 (5.09)       418.6743 (23.23)     1.5177 (7.83)          3;0   2.3898 (0.04)          5           1
test_brotli[kppkn.gtb-cramjam]                       440.9632 (24.63)      443.1299 (23.87)      442.1863 (24.44)     1.1046 (6.77)       442.8029 (24.57)     2.0629 (10.64)         2;0   2.2615 (0.04)          5           1
test_brotli[lcet10.txt-brotli]                       689.7913 (38.53)      743.3864 (40.05)      717.3455 (39.66)    24.4643 (149.97)     729.2844 (40.47)    42.6345 (219.83)        3;0   1.3940 (0.03)          5           1
test_brotli[lcet10.txt-cramjam]                      721.1161 (40.28)      732.6687 (39.47)      724.4550 (40.05)     4.6831 (28.71)      723.2143 (40.14)     3.9332 (20.28)         1;1   1.3803 (0.02)          5           1
test_brotli[paper-100k.pdf-brotli]                   394.1195 (22.02)      396.6882 (21.37)      395.3076 (21.85)     1.1796 (7.23)       394.7834 (21.91)     2.1113 (10.89)         2;0   2.5297 (0.05)          5           1
test_brotli[paper-100k.pdf-cramjam]                  400.0918 (22.35)      403.0363 (21.71)      401.5485 (22.20)     1.2038 (7.38)       401.7684 (22.30)     1.9826 (10.22)         2;0   2.4904 (0.05)          5           1
test_brotli[plrabn12.txt-brotli]                     753.8846 (42.11)      758.9727 (40.89)      756.4733 (41.82)     2.1144 (12.96)      756.1968 (41.97)     3.5936 (18.53)         2;0   1.3219 (0.02)          5           1
test_brotli[plrabn12.txt-cramjam]                    794.5884 (44.39)      802.1071 (43.21)      796.4616 (44.03)     3.1963 (19.59)      795.1971 (44.13)     2.7926 (14.40)         1;1   1.2556 (0.02)          5           1
test_brotli[urls.10K-brotli]                       1,219.2465 (68.11)    1,227.4113 (66.12)    1,224.0802 (67.67)     3.1470 (19.29)    1,224.5238 (67.96)     4.2651 (21.99)         2;0   0.8169 (0.01)          5           1
test_brotli[urls.10K-cramjam]                      1,272.6277 (71.09)    1,285.8821 (69.27)    1,279.8358 (70.75)     5.4317 (33.30)    1,278.5339 (70.95)     8.5926 (44.30)         2;0   0.7814 (0.01)          5           1
--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
```

#### ZSTD

`make bench-zstd`

```bash 
------------------------------------------------------------------------------------------------------- benchmark: 24 tests --------------------------------------------------------------------------------------------------------
Name (time in us)                                       Min                    Max                  Mean              StdDev                Median                 IQR            Outliers         OPS            Rounds  Iterations
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
test_zstd[Mark.Twain-Tom.Sawyer.txt-cramjam]       161.1050 (1.0)         433.4360 (1.45)       165.1466 (1.0)       12.3976 (1.0)        162.1550 (1.0)        0.6950 (1.0)       100;276  6,055.2258 (1.0)        1585           1
test_zstd[Mark.Twain-Tom.Sawyer.txt-zstd]          220.8000 (1.37)        299.4960 (1.0)        249.8003 (1.51)      17.7341 (1.43)       256.9255 (1.58)      30.2230 (43.49)        17;0  4,003.1981 (0.66)         50           1
test_zstd[alice29.txt-cramjam]                   1,421.3080 (8.82)      2,037.1450 (6.80)     1,472.4503 (8.92)      66.0363 (5.33)     1,451.2480 (8.95)      61.9850 (89.19)       74;21    679.1401 (0.11)        615           1
test_zstd[alice29.txt-zstd]                      1,317.3690 (8.18)      2,371.9740 (7.92)     1,365.1289 (8.27)      95.6726 (7.72)     1,343.0765 (8.28)      44.4860 (64.01)       35;57    732.5316 (0.12)        684           1
test_zstd[asyoulik.txt-cramjam]                  1,256.8620 (7.80)      1,715.7540 (5.73)     1,294.9080 (7.84)      49.4700 (3.99)     1,280.9885 (7.90)      41.7850 (60.12)       82;51    772.2556 (0.13)        698           1
test_zstd[asyoulik.txt-zstd]                     1,156.5710 (7.18)      1,736.3310 (5.80)     1,189.7247 (7.20)      45.2945 (3.65)     1,178.9070 (7.27)      42.4503 (61.08)      103;47    840.5306 (0.14)        837           1
test_zstd[fireworks.jpeg-cramjam]                  283.7220 (1.76)        502.0290 (1.68)       300.4003 (1.82)      24.4473 (1.97)       293.7890 (1.81)      19.9285 (28.67)     301;184  3,328.8915 (0.55)       2620           1
test_zstd[fireworks.jpeg-zstd]                     216.5220 (1.34)        586.8800 (1.96)       235.8188 (1.43)      28.7429 (2.32)       223.4890 (1.38)      19.2512 (27.70)     310;265  4,240.5432 (0.70)       3205           1
test_zstd[geo.protodata-cramjam]                   330.2580 (2.05)        523.4440 (1.75)       341.2278 (2.07)      20.4295 (1.65)       332.8170 (2.05)      10.0517 (14.46)     196;208  2,930.5937 (0.48)       2083           1
test_zstd[geo.protodata-zstd]                      280.5380 (1.74)        512.8140 (1.71)       292.1102 (1.77)      18.6813 (1.51)       285.3240 (1.76)       7.8345 (11.27)     257;405  3,423.3652 (0.57)       3007           1
test_zstd[html-cramjam]                            357.8320 (2.22)        648.3850 (2.16)       369.4639 (2.24)      24.1993 (1.95)       359.8050 (2.22)      10.8335 (15.59)     155;207  2,706.6244 (0.45)       2036           1
test_zstd[html-zstd]                               311.9870 (1.94)        561.2720 (1.87)       319.6523 (1.94)      15.3747 (1.24)       314.0850 (1.94)       3.5158 (5.06)      269;608  3,128.3989 (0.52)       2879           1
test_zstd[html_x_4-cramjam]                        465.3780 (2.89)     16,841.4000 (56.23)      555.1090 (3.36)     450.9177 (36.37)      505.6665 (3.12)      60.2160 (86.64)      16;185  1,801.4481 (0.30)       1388           1
test_zstd[html_x_4-zstd]                           365.6660 (2.27)        625.7230 (2.09)       384.4546 (2.33)      28.6141 (2.31)       369.0950 (2.28)      23.1068 (33.25)     200;138  2,601.0872 (0.43)       1765           1
test_zstd[kppkn.gtb-cramjam]                     1,124.4530 (6.98)      2,338.1150 (7.81)     1,277.8409 (7.74)     165.0912 (13.32)    1,223.1610 (7.54)     105.8960 (152.37)      71;69    782.5700 (0.13)        659           1
test_zstd[kppkn.gtb-zstd]                        1,045.2590 (6.49)      2,456.0800 (8.20)     1,159.7191 (7.02)     211.4021 (17.05)    1,098.6080 (6.78)      76.0943 (109.49)      66;87    862.2778 (0.14)        893           1
test_zstd[lcet10.txt-cramjam]                    3,681.4250 (22.85)     7,913.6370 (26.42)    4,061.2618 (24.59)    464.6470 (37.48)    3,955.3625 (24.39)    318.0175 (457.58)      13;10    246.2289 (0.04)        244           1
test_zstd[lcet10.txt-zstd]                       3,409.9820 (21.17)     6,680.4900 (22.31)    3,815.8187 (23.11)    479.5487 (38.68)    3,653.2820 (22.53)    351.3137 (505.49)      23;20    262.0670 (0.04)        255           1
test_zstd[paper-100k.pdf-cramjam]                  493.9780 (3.07)      1,139.2420 (3.80)       508.1456 (3.08)      31.2199 (2.52)       496.2745 (3.06)      19.9030 (28.64)       71;58  1,967.9400 (0.32)       1026           1
test_zstd[paper-100k.pdf-zstd]                     479.7970 (2.98)        716.8680 (2.39)       495.2747 (3.00)      27.0047 (2.18)       483.4690 (2.98)      19.1000 (27.48)     171;115  2,019.0817 (0.33)       1639           1
test_zstd[plrabn12.txt-cramjam]                  4,967.6940 (30.84)     5,992.0030 (20.01)    5,086.0596 (30.80)    130.3956 (10.52)    5,055.3775 (31.18)    132.6160 (190.81)       12;6    196.6159 (0.03)        166           1
test_zstd[plrabn12.txt-zstd]                     4,617.7570 (28.66)     5,760.2680 (19.23)    4,726.4604 (28.62)    116.1931 (9.37)     4,694.4440 (28.95)    120.5897 (173.51)       20;9    211.5748 (0.03)        211           1
test_zstd[urls.10K-cramjam]                      4,553.1040 (28.26)     5,873.6000 (19.61)    4,724.6278 (28.61)    150.2981 (12.12)    4,694.5230 (28.95)    180.9015 (260.29)       39;3    211.6569 (0.03)        197           1
test_zstd[urls.10K-zstd]                         4,198.9830 (26.06)     6,017.4010 (20.09)    4,444.2599 (26.91)    258.4360 (20.85)    4,379.3710 (27.01)    191.9520 (276.19)      18;17    225.0093 (0.04)        231           1
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
```




